/*
 * chaucer.h
 *
 * Provides excerpts from Chaucer's Canterbury Tales as PROGDATA strings under 32 kB
 *
 * published under GNU General Public License, version 3 (GPL-3.0)
 * author Stefan Rueger
 *
 * v 1.0
 * 02.01.2021
 */

#ifndef CHAUCER_H
#define CHAUCER_H

// Text is an extract from The Canterbury Tales
// full text at http://www.gutenberg.org/cache/epub/2383/pg2383.txt
#include <config.h>

// Application can choose between PROGDATA, PROGTEXT and PROGMEM in config.h
#ifndef PGMSECTION
#define PGMSECTION PROGDATA
#endif

extern const char tocPreface[] PGMSECTION; // 12355 bytes
extern const char lifeOfGeoffreyChaucer0[] PGMSECTION; // 28883 bytes
extern const char lifeOfGeoffreyChaucer1[] PGMSECTION; // 26320 bytes
extern const char prologue0[] PGMSECTION; // 26305 bytes
extern const char prologue1[] PGMSECTION; // 24817 bytes
// FLASHEND <  16383:   2534 bytes
// FLASHEND >= 16383:  12165 bytes
extern const char knightsTale0[] PGMSECTION; // 27944 bytes
extern const char knightsTale1[] PGMSECTION; // 31125 bytes
extern const char knightsTale2[] PGMSECTION; // 32199 bytes
extern const char knightsTale3[] PGMSECTION; // 32146 bytes
extern const char millersTale0[] PGMSECTION; // 21441 bytes
extern const char millersTale1[] PGMSECTION; // 23069 bytes
extern const char reevesTale[] PGMSECTION; // 28666 bytes
extern const char cooksTale[] PGMSECTION; // 6372 bytes
extern const char manOfLawsTale0[] PGMSECTION; // 31057 bytes
extern const char manOfLawsTale1[] PGMSECTION; // 30786 bytes
extern const char wifeOfBathsTale0[] PGMSECTION; // 23554 bytes
extern const char wifeOfBathsTale1[] PGMSECTION; // 23215 bytes
extern const char wifeOfBathsTale2[] PGMSECTION; // 22808 bytes
extern const char friarsTale[] PGMSECTION; // 22255 bytes
extern const char sompnoursTale0[] PGMSECTION; // 17515 bytes
extern const char sompnoursTale1[] PGMSECTION; // 17709 bytes
extern const char clerksTale0[] PGMSECTION; // 31698 bytes
extern const char clerksTale1[] PGMSECTION; // 31577 bytes
extern const char merchantsTale0[] PGMSECTION; // 32217 bytes
extern const char merchantsTale1[] PGMSECTION; // 32199 bytes
extern const char squiresTale0[] PGMSECTION; // 21394 bytes
extern const char squiresTale1[] PGMSECTION; // 19973 bytes
extern const char franklinsTale0[] PGMSECTION; // 24957 bytes
extern const char franklinsTale1[] PGMSECTION; // 25907 bytes
extern const char doctorsTale[] PGMSECTION; // 15255 bytes
extern const char pardonersTale0[] PGMSECTION; // 18988 bytes
extern const char pardonersTale1[] PGMSECTION; // 19689 bytes
extern const char shipmansTale[] PGMSECTION; // 24603 bytes
extern const char prioresssTale[] PGMSECTION; // 14608 bytes
extern const char taleOfSirThopas[] PGMSECTION; // 14428 bytes
extern const char taleOfMeliboeus0[] PGMSECTION; // 25796 bytes
extern const char taleOfMeliboeus1[] PGMSECTION; // 16704 bytes
extern const char monksTale0[] PGMSECTION; // 24314 bytes
extern const char monksTale1[] PGMSECTION; // 24248 bytes
extern const char nunsPriestsTale0[] PGMSECTION; // 22474 bytes
extern const char nunsPriestsTale1[] PGMSECTION; // 21866 bytes
extern const char secondNunsTale[] PGMSECTION; // 30027 bytes
extern const char canonsYeomansTale0[] PGMSECTION; // 26766 bytes
extern const char canonsYeomansTale1[] PGMSECTION; // 25077 bytes
extern const char manciplesTale[] PGMSECTION; // 20689 bytes
extern const char parsonsTale0[] PGMSECTION; // 31554 bytes
extern const char parsonsTale1[] PGMSECTION; // 25736 bytes
extern const char precesDeChauceres[] PGMSECTION; // 3621 bytes
extern const char poemTheCourtOfLove0[] PGMSECTION; // 32649 bytes
extern const char poemTheCourtOfLove1[] PGMSECTION; // 32306 bytes
extern const char poemTheCuckooAndTheNightingale[] PGMSECTION; // 19627 bytes
extern const char poemTheAssemblyOfFowls0[] PGMSECTION; // 27111 bytes
extern const char poemTheAssemblyOfFowls1[] PGMSECTION; // 27146 bytes
extern const char poemTheFlowerAndTheLeaf0[] PGMSECTION; // 18609 bytes
extern const char poemTheFlowerAndTheLeaf1[] PGMSECTION; // 18883 bytes
extern const char poemTheHouseOfFame0[] PGMSECTION; // 27648 bytes
extern const char poemTheHouseOfFame1[] PGMSECTION; // 27656 bytes
extern const char poemTheHouseOfFame2[] PGMSECTION; // 27771 bytes
extern const char poemTroilusAndCressida0[] PGMSECTION; // 31183 bytes
extern const char poemTroilusAndCressida1[] PGMSECTION; // 31260 bytes
extern const char poemTroilusAndCressida2[] PGMSECTION; // 31149 bytes
extern const char poemTroilusAndCressida3[] PGMSECTION; // 31188 bytes
extern const char poemTroilusAndCressida4[] PGMSECTION; // 30888 bytes
extern const char poemChaucersDream0[] PGMSECTION; // 17116 bytes
extern const char poemChaucersDream1[] PGMSECTION; // 16017 bytes
extern const char prologueToTheLegendOfGoodWomen0[] PGMSECTION; // 18988 bytes
extern const char prologueToTheLegendOfGoodWomen1[] PGMSECTION; // 18872 bytes
extern const char chaucersABC[] PGMSECTION; // 11674 bytes
extern const char miscellaneousPoems[] PGMSECTION; // 15956 bytes

#endif
