/*
 * bootloader_size.h
 *
 * define either BOOTLOADER_SIZE or BOOTLOADER_MINSIZE and BOOTLOADER_MAXSIZE, as the case may be
 *
 * published under GNU General Public License, version 3 (GPL-3.0)
 * author Stefan Rueger
 * v 1.0
 * 18.12.2021
 */

#ifndef BOOTLOADER_SIZE_H
#define BOOTLOADER_SIZE_H

// Bootloader size(s) that this processor has, if any

#if defined(__AVR_ATtiny10) || defined(__AVR_ATtiny20) || defined(__AVR_ATtiny40) || defined(__AVR_ATtiny4) || defined(__AVR_ATtiny5) || defined(__AVR_ATtiny9) || \
  defined(__AVR_ATmega48) || defined(__AVR_ATmega48A) || defined(__AVR_ATmega48P) || defined(__AVR_ATmega48PA) || \
  defined(__AVR_ATtiny13) || defined(__AVR_ATtiny13A) || \
  defined(__AVR_ATtiny24) || defined(__AVR_ATtiny24A) || \
  defined(__AVR_ATtiny25) || \
  defined(__AVR_ATtiny261) || defined(__AVR_ATtiny261A) || \
  defined(__AVR_ATtiny26) || \
  defined(__AVR_ATtiny28) || \
  defined(__AVR_ATtiny43U) || \
  defined(__AVR_ATtiny44) || defined(__AVR_ATtiny44A) || \
  defined(__AVR_ATtiny45) || \
  defined(__AVR_ATtiny48) || \
  defined(__AVR_ATtiny84) || defined(__AVR_ATtiny84A) || \
  defined(__AVR_ATtiny85) || \
  defined(__AVR_ATtiny87) || \
  defined(__AVR_ATtiny88) || \
  defined(__AVR_ATtiny167) || \
  defined(__AVR_ATtiny4313) || \
  defined(__AVR_ATtiny461) || defined(__AVR_ATtiny461A) || \
  defined(__AVR_ATtiny861) || defined(__AVR_ATtiny861A) || \
  defined(__AVR_ATtiny1634) || \
  defined(__AVR_ATtiny2313) || defined(__AVR_ATtiny2313A)

#define BOOTLOADER_SIZE 0 // this part has no dedicated bootloader space

#elif defined(__AVR_AT90PWM1__) || defined(__AVR_AT90PWM161__) || defined(__AVR_AT90PWM2B__) || defined(__AVR_AT90PWM3B__) || defined(__AVR_AT90PWM81__) || \
  defined(__AVR_ATA6285__) || defined(__AVR_ATA6286__) || \
  defined(__AVR_ATmega16__) || defined(__AVR_ATmega162__) || defined(__AVR_ATmega164A__) || defined(__AVR_ATmega164P__) || defined(__AVR_ATmega164PA__) || \
  defined(__AVR_ATmega165A__) || defined(__AVR_ATmega165P__) || defined(__AVR_ATmega165PA__) || \
  defined(__AVR_ATmega168__) || defined(__AVR_ATmega168A__) || defined(__AVR_ATmega168P__) || defined(__AVR_ATmega168PA__) || \
  defined(__AVR_ATmega169A__) || defined(__AVR_ATmega169P__) || defined(__AVR_ATmega169PA__) || \
  defined(__AVR_ATmega16A__) || defined(__AVR_ATmega8__) || defined(__AVR_ATmega8A__) || \
  defined(__AVR_ATmega8515__) || defined(__AVR_ATmega8535__) || \
  defined(__AVR_ATmega88__) || defined(__AVR_ATmega88A__) || defined(__AVR_ATmega88P__) || defined(__AVR_ATmega88PA__) || \
  defined(__AVR_ATtiny828__)

#define BOOTLOADER_MINSIZE 0x100
#define BOOTLOADER_MAXSIZE 0x400

#elif defined(__AVR_AT90PWM216__) || defined(__AVR_AT90PWM316__) || defined(__AVR_AT90USB162__) || defined(__AVR_AT90USB82__) || \
  defined(__AVR_ATmega16HVB__) || defined(__AVR_ATmega16M1__) || defined(__AVR_ATmega16U2__) || defined(__AVR_ATmega16U4__) || \
  defined(__AVR_ATmega8U2__) || \
  defined(__AVR_ATmega32__) || defined(__AVR_ATmega32A__) || defined(__AVR_ATmega32C1__) || defined(__AVR_ATmega32HVB__) || \
  defined(__AVR_ATmega32M1__) || defined(__AVR_ATmega32U2__) || defined(__AVR_ATmega32U4__) || \
  defined(__AVR_ATmega324A__) || defined(__AVR_ATmega324P__) || defined(__AVR_ATmega324PA__) || \
  defined(__AVR_ATmega325__) || defined(__AVR_ATmega325A__) || defined(__AVR_ATmega325P__) || defined(__AVR_ATmega325PA__) || \
  defined(__AVR_ATmega3250__) || defined(__AVR_ATmega3250A__) || defined(__AVR_ATmega3250P__) || defined(__AVR_ATmega3250PA__) || \
  defined(__AVR_ATmega328__) || defined(__AVR_ATmega328P__) || defined(__AVR_ATmega329__) || \
  defined(__AVR_ATmega329A__) || defined(__AVR_ATmega329P__) || defined(__AVR_ATmega329PA__) || \
  defined(__AVR_ATmega3290__) || defined(__AVR_ATmega3290A__) || defined(__AVR_ATmega3290P__) || defined(__AVR_ATmega3290PA__)

#define BOOTLOADER_MINSIZE 0x200
#define BOOTLOADER_MAXSIZE 0x800

#elif defined(__AVR_AT90CAN128_) || defined(__AVR_AT90CAN32_) || defined(__AVR_AT90CAN64_) || \
  defined(__AVR_AT90USB646_) || defined(__AVR_AT90USB647_) || \
  defined(__AVR_AT90USB1286_) || defined(__AVR_AT90USB1287_) || \
  defined(__AVR_ATmega1280_) || defined(__AVR_ATmega1281_) || defined(__AVR_ATmega1284_) || defined(__AVR_ATmega1284P_) || \
  defined(__AVR_ATmega128_) || defined(__AVR_ATmega128A_) || defined(__AVR_ATmega128RFA1_) || \
  defined(__AVR_ATmega2560_) || defined(__AVR_ATmega2561_) || \
  defined(__AVR_ATmega640_) || \
  defined(__AVR_ATmega644_) || defined(__AVR_ATmega644A_) || defined(__AVR_ATmega644P_) || defined(__AVR_ATmega644PA_) || \
  defined(__AVR_ATmega6450_) || defined(__AVR_ATmega6450A_) ||  defined(__AVR_ATmega6450P_) || \
  defined(__AVR_ATmega645_) || defined(__AVR_ATmega645A_) || defined(__AVR_ATmega645P_) || \
  defined(__AVR_ATmega6490_) || defined(__AVR_ATmega6490A_) || defined(__AVR_ATmega6490P_) || \
  defined(__AVR_ATmega649_) || defined(__AVR_ATmega649A_) || defined(__AVR_ATmega649P_) || \
  defined(__AVR_ATmega64_) || defined(__AVR_ATmega64A_) || defined(__AVR_ATmega64C1_) || defined(__AVR_ATmega64M1_)

#define BOOTLOADER_MINSIZE 0x400
#define BOOTLOADER_MAXSIZE 0x1000

#elif defined(__AVR_ATxmega16A4_) || defined(__AVR_ATxmega16A4U_) || defined(__AVR_ATxmega16C4_) || defined(__AVR_ATxmega16D4_) || \
  defined(__AVR_ATxmega32A4_) || defined(__AVR_ATxmega32A4U_) || defined(__AVR_ATxmega32C4_) || defined(__AVR_ATxmega32D4_) || \
  defined(__AVR_ATxmega64A1_) || defined(__AVR_ATxmega64A1U_) || defined(__AVR_ATxmega64A3_) || defined(__AVR_ATxmega64A3U_) || defined(__AVR_ATxmega64A4U_) || \
  defined(__AVR_ATxmega64B1_) || defined(__AVR_ATxmega64B3_) || defined(__AVR_ATxmega64C3_) || defined(__AVR_ATxmega64D3_) || defined(__AVR_ATxmega64D4_)

#define BOOTLOADER_SIZE 0x1000

#elif defined(__AVR_ATxmega128A1_) || defined(__AVR_ATxmega128A1U_) || defined(__AVR_ATxmega128A3_) || \
  defined(__AVR_ATxmega128A3U_) || defined(__AVR_ATxmega128A4U_) || defined(__AVR_ATxmega128B1_) || defined(__AVR_ATxmega128B3_) || \
  defined(__AVR_ATxmega128C3_) || defined(__AVR_ATxmega128D3_) ||  defined(__AVR_ATxmega128D4_) || \
  defined(__AVR_ATxmega192A3_) || defined(__AVR_ATxmega192A3U_) || defined(__AVR_ATxmega192C3_) || defined(__AVR_ATxmega192D3_) || \
  defined(__AVR_ATxmega256A3_) || defined(__AVR_ATxmega256A3B_) || defined(__AVR_ATxmega256A3BU_) || defined(__AVR_ATxmega256A3U_) || \
  defined(__AVR_ATxmega256C3_) || defined(__AVR_ATxmega256D3_) || \
  defined(__AVR_ATxmega384C3_) || defined(__AVR_ATxmega384D3_)

#define BOOTLOADER_SIZE 0x2000

#endif

#endif
